/*
 *	game.c
 */
#include "app.h"

static int trial();
static int battle();

/****************************************************************************
 *	next_rand
 ****************************************************************************/

unsigned char
next_rand()
{
	next_seed = next_seed * 5 + 0x3711;
	return (unsigned char)(next_seed >> 8);
}

/****************************************************************************
 *	next_init
 ****************************************************************************/

void
next_init()
{
	next_seed = (unsigned short)pceTimerGetCount();
	next_get(NULL);
}

/****************************************************************************
 *	next_get
 ****************************************************************************/

/* 0:		1:		2:		3:	
 * 							
 * 		4:		5:		6:	
 *							
 */
static int next_tbl[8] = { 0,0,1,2,3,4,5,6 };
#define SUPER_RATE	63	/* (next_rand()&SUPER_RATE)=0ŏo */

void
next_get(CELL quad[2][2])
{
	int col, row;
	CELL *cell, *cel2;

	/* ݂NEXTZ擾܂B */
	if(quad != NULL) memcpy(quad, next, sizeof next);

	/* VNEXTZ𐶐܂B */
	switch(next_tbl[next_rand() & 7]) {
	case 0:
		for(row = 0; row < 2; row++) {
			for(col = 0; col < 2; col++) {
				cell = &next[row][col];
				if((next_rand() & SUPER_RATE) == 0) {
					cell->color = CC_SUPER;
				} else {
					cell->color = CC_WHITE + (next_rand() & 3);
				}
				cell->type = CT_SINGLE;
			}
		}
		break;
	case 1:
		for(row = 0; row < 1; row++) {
			for(col = 0; col < 2; col++) {
				cell = &next[row][col];
				if((next_rand() & SUPER_RATE) == 0) {
					cell->color = CC_SUPER;
				} else {
					cell->color = CC_WHITE + (next_rand() & 3);
				}
				cell->type = CT_SINGLE;
			}
		}
		for(row = 1; row < 2; row++) {
			cell = &next[row][0];
			cel2 = &next[row][1];
			cell->color = CC_WHITE + (next_rand() & 3);
			cell->type = CT_LEFT;
			cel2->color = cell->color;
			cel2->type = CT_RIGHT;
		}
		break;
	case 2:
		for(row = 1; row < 2; row++) {
			for(col = 0; col < 2; col++) {
				cell = &next[row][col];
				if((next_rand() & SUPER_RATE) == 0) {
					cell->color = CC_SUPER;
				} else {
					cell->color = CC_WHITE + (next_rand() & 3);
				}
				cell->type = CT_SINGLE;
			}
		}
		for(row = 0; row < 1; row++) {
			cell = &next[row][0];
			cel2 = &next[row][1];
			cell->color = CC_WHITE + (next_rand() & 3);
			cell->type = CT_LEFT;
			cel2->color = cell->color;
			cel2->type = CT_RIGHT;
		}
		break;
	case 3:
		for(row = 0; row < 2; row++) {
			cell = &next[row][0];
			cel2 = &next[row][1];
			cell->color = CC_WHITE + (next_rand() & 3);
			cell->type = CT_LEFT;
			cel2->color = cell->color;
			cel2->type = CT_RIGHT;
		}
		break;
	case 4:
		for(row = 0; row < 2; row++) {
			for(col = 0; col < 1; col++) {
				cell = &next[row][col];
				if((next_rand() & SUPER_RATE) == 0) {
					cell->color = CC_SUPER;
				} else {
					cell->color = CC_WHITE + (next_rand() & 3);
				}
				cell->type = CT_SINGLE;
			}
		}
		for(col = 1; col < 2; col++) {
			cell = &next[0][col];
			cel2 = &next[1][col];
			cell->color = CC_WHITE + (next_rand() & 3);
			cell->type = CT_UPPER;
			cel2->color = cell->color;
			cel2->type = CT_UNDER;
		}
		break;
	case 5:
		for(row = 0; row < 2; row++) {
			for(col = 1; col < 2; col++) {
				cell = &next[row][col];
				if((next_rand() & SUPER_RATE) == 0) {
					cell->color = CC_SUPER;
				} else {
					cell->color = CC_WHITE + (next_rand() & 3);
				}
				cell->type = CT_SINGLE;
			}
		}
		for(col = 0; col < 1; col++) {
			cell = &next[0][col];
			cel2 = &next[1][col];
			cell->color = CC_WHITE + (next_rand() & 3);
			cell->type = CT_UPPER;
			cel2->color = cell->color;
			cel2->type = CT_UNDER;
		}
		break;
	case 6:
		for(col = 0; col < 2; col++) {
			cell = &next[0][col];
			cel2 = &next[1][col];
			cell->color = CC_WHITE + (next_rand() & 3);
			cell->type = CT_UPPER;
			cel2->color = cell->color;
			cel2->type = CT_UNDER;
		}
		break;
	default:
		DIE();
	}
}

/****************************************************************************
 *	game
 ****************************************************************************/

static char msg_ready[] = "READY?";
static char msg_gover[] = "GAMEOVER";

void
game(int type)
{
	int score;

	score = 0; /*RpCx}*/

	BSET(state, STATE_GAME);
	game_task = task_new(root_task, 0);

	switch(type) {
	case 0:
		score = trial();
		break;
	case 1:
		score = battle();
		break;
	default:
		DIE();
	}

	task_free(game_task);
	BCLR(state, STATE_GAME);

	/* :l[Gg[Ogame_taskJȂƁA
	 *      tB[h\Ă܂܂B
	 */
	if(score != -1) nameentry(type, score);
}

/****************************************************************************
 *	trial
 ****************************************************************************/

static int
trial()
{
	int i, x, y, failed;
	FIELD* field;

	/* v\B */
	BSET(state, STATE_FLDINF);

	/* ʂNA܂B */
	bg_clear(0);
	sprite_clear_all();

	/* NEXT܂B */
	next_init();
	t_next(); /* NEXT\^XNJn */

	/* tB[h܂B */
	field = &fields[0];	/*P1tB[ĥݎgp*/
	field_init(field, 0);
	t_field(field); /* tB[h\^XNJn */

	/* tB[hȂǕ\B */
	bg_block(0, 0, 0, CHR_FIELD, 16, 11);
	sprite_print(SPR_MSG, 40, 32, msg_ready);

	/* CvCB */
	t_wipe(1);
	do {
		period();
	} while(BTST(state, STATE_WIPE));

	/* Ƒ҂B */
	for(i = 0; i < SEC(1); i++) period();

	/* bZ[WB */
	for(i = 0; i < 6; i++) {
		sprite_clear(SPR_MSG + i, 1);
		x = 40 + 8 * i - 4;
		y = 32         - 4;
		hamon_new(2, x, y);
		period();
	}

	/* Q[[vB */
	failed = 0;
	for(;;) {
		/* EŃtF[YIƂŁAxEIB */
		if(field->mode == FM_CTRL_INIT) {
			if(field->ctrl_done == TRIAL_WARN_COUNT) sound_start(3, WARN1);
			if(field->ctrl_done == TRIAL_TERM_COUNT) break;
		}

		/* P1B */
		if(!field_proc(field, field_think(field))) {
			failed = 1; /* sIAl[Gg[Ȃ */
			break;
		}
		period();
	}
	period();

	/* Ƒ҂B */
	for(i = 0; i < SEC(1); i++) period();
	sound_start(3, BOMB4);

	/* NEXTZޏB */
	BCLR(state, STATE_NEXT);

	/* bZ[W\B */
	for(i = 0; i < sizeof msg_gover / sizeof *msg_gover; i++) {
		x = 32 + 8 * i;
		y = 32;
		sprite_block(SPR_MSG + i, x, y, msg_gover[i] & 0xFF, 1, 1);
		hamon_new(2, x, y);
		period();
	}

	/* Ƒ҂B */
	for(i = 0; i < SEC(3); i++) {
		if(pad & (TRG_A | TRG_B)) break;
		period();
	}

	/* CvAEg̑OɁAv(BG#1Ȃ̂)B */
	BCLR(state, STATE_FLDINF);

	/* CvAEgB */
	t_wipe(0);
	do {
		period();
	} while(BTST(state, STATE_WIPE));

	/* l[Gg[B */
	return failed ? -1 : field->combo_max;
}

/****************************************************************************
 *	battle
 ****************************************************************************/

static void
show_elapse(int elapse)
{
	bg_print(1, 4, 10, time_str(elapse));
}

static int
battle()
{
	int i, x, y, failed, elapse;
	FIELD* field;

	/* v\ȂB */
	BCLR(state, STATE_FLDINF);

	/* ʂNA܂B */
	bg_clear(0);
	sprite_clear_all();

	/* NEXT܂B */
	next_init();
	t_next(); /* NEXT\^XNJn */

	/* tB[h܂B */
	for(i = 0; i < 2; i++) {
		field = &fields[i];
		field_init(field, i);
		t_field(field); /* tB[h\^XNJn */
	}

	/* tB[hȂǕ\B */
	bg_block(0, 0, 0, CHR_FIELD, 16, 11);
	sprite_print(SPR_MSG, 40, 32, msg_ready);

	/* CvCB */
	t_wipe(1);
	do {
		period();
	} while(BTST(state, STATE_WIPE));

	/* Ƒ҂B */
	for(i = 0; i < SEC(1); i++) period();

	/* bZ[WB */
	for(i = 0; i < 6; i++) {
		sprite_clear(SPR_MSG + i, 1);
		x = 40 + 8 * i - 4;
		y = 32         - 4;
		hamon_new(2, x, y);
		period();
	}

	/* ŏ̐Z𓯂ɂ邽߁A
	 * TCh񂸂(FM_CTRL_INIT)ĂA
	 * ZRs[܂B
	 */
	field_proc(&fields[0], 0);
	field_proc(&fields[1], 0);
	memcpy(fields[0].quad, fields[1].quad, sizeof fields[1].quad);

	/* Q[[vB */
	failed = 0;
	elapse = 0;
	for(;;) {
		/* xƏIB */
		if(elapse == SEC(BATTLE_WARN_SEC)) sound_start(3, WARN1);
		if(elapse == SEC(BATTLE_TERM_SEC)) {
			failed = 1; /* ^CAEgAl[Gg[Ȃ */
			break;
		}
		/* P1B */
		field = &fields[0];
		if(!field_proc(field, field_think(field))) {
			failed = 1; /* sIAl[Gg[Ȃ */
			break;
		}
		/* P2B */
		field = &fields[1];
		if(!field_proc(field, field_think(field))) break;
		/* \Ai߂B */
		show_elapse(elapse);
		elapse++;
		period();
	}
	show_elapse(elapse); /* 3҂̕\B */
	period();

	/* Ƒ҂B */
	for(i = 0; i < SEC(1); i++) period();
	sound_start(3, BOMB4);

	/* NEXTZޏB */
	BCLR(state, STATE_NEXT);

	/* bZ[W\B */
	for(i = 0; i < sizeof msg_gover / sizeof *msg_gover; i++) {
		x = 32 + 8 * i;
		y = 32;
		sprite_block(SPR_MSG + i, x, y, msg_gover[i] & 0xFF, 1, 1);
		hamon_new(2, x, y);
		period();
	}

	/* Ƒ҂B */
	for(i = 0; i < SEC(3); i++) {
		if(pad & (TRG_A | TRG_B)) break;
		period();
	}

	/* CvAEgB */
	t_wipe(0);
	do {
		period();
	} while(BTST(state, STATE_WIPE));

	/* l[Gg[B */
	return failed ? -1 : elapse;
}
